Index: drivers/filesystems/btrfs/balance.c
===================================================================
--- drivers/filesystems/btrfs/balance.c	(révision 75772)
+++ drivers/filesystems/btrfs/balance.c	(copie de travail)
@@ -522,171 +566,170 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS write_metadata_items(device_extension* Vcb, LIST_ENTRY* items, LIST_ENTRY* data_items, chunk* c, LIST_ENTRY* rollback) {
+static NTSTATUS write_metadata_items(_Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, LIST_ENTRY* items,
+                                     LIST_ENTRY* data_items, chunk* c, LIST_ENTRY* rollback) {
     LIST_ENTRY tree_writes, *le;
     NTSTATUS Status;
     traverse_ptr tp;
     UINT8 level, max_level = 0;
     chunk* newchunk = NULL;
-    
+
     InitializeListHead(&tree_writes);
-    
+
     le = items->Flink;
     while (le != items) {
         metadata_reloc* mr = CONTAINING_RECORD(le, metadata_reloc, list_entry);
         LIST_ENTRY* le2;
         chunk* pc;
-        
-//         ERR("address %llx\n", mr->address);
-        
+
         mr->data = ExAllocatePoolWithTag(PagedPool, Vcb->superblock.node_size, ALLOC_TAG);
         if (!mr->data) {
             ERR("out of memory\n");
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         Status = read_data(Vcb, mr->address, Vcb->superblock.node_size, NULL, TRUE, (UINT8*)mr->data,
-                           c && mr->address >= c->offset && mr->address < c->offset + c->chunk_item->size ? c : NULL, &pc, NULL, FALSE);
+                           c && mr->address >= c->offset && mr->address < c->offset + c->chunk_item->size ? c : NULL, &pc, NULL, 0, FALSE, NormalPagePriority);
         if (!NT_SUCCESS(Status)) {
             ERR("read_data returned %08x\n", Status);
             return Status;
         }
-        
+
         if (pc->chunk_item->type & BLOCK_FLAG_SYSTEM)
             mr->system = TRUE;
-        
+
         if (data_items && mr->data->level == 0) {
-            LIST_ENTRY* le2 = data_items->Flink;
+            le2 = data_items->Flink;
             while (le2 != data_items) {
                 data_reloc* dr = CONTAINING_RECORD(le2, data_reloc, list_entry);
                 leaf_node* ln = (leaf_node*)&mr->data[1];
                 UINT16 i;
-                
+
                 for (i = 0; i < mr->data->num_items; i++) {
                     if (ln[i].key.obj_type == TYPE_EXTENT_DATA && ln[i].size >= sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2)) {
                         EXTENT_DATA* ed = (EXTENT_DATA*)((UINT8*)mr->data + sizeof(tree_header) + ln[i].offset);
-                        
+
                         if (ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) {
                             EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ed->data;
-                            
+
                             if (ed2->address == dr->address)
                                 ed2->address = dr->new_address;
                         }
                     }
                 }
-                
+
                 le2 = le2->Flink;
             }
         }
-        
+
         if (mr->data->level > max_level)
             max_level = mr->data->level;
-        
+
         le2 = mr->refs.Flink;
         while (le2 != &mr->refs) {
             metadata_reloc_ref* ref = CONTAINING_RECORD(le2, metadata_reloc_ref, list_entry);
-            
+
             if (ref->type == TYPE_TREE_BLOCK_REF) {
                 KEY* firstitem;
                 root* r = NULL;
                 LIST_ENTRY* le3;
                 tree* t;
-                
+
                 firstitem = (KEY*)&mr->data[1];
-                
+
                 le3 = Vcb->roots.Flink;
                 while (le3 != &Vcb->roots) {
                     root* r2 = CONTAINING_RECORD(le3, root, list_entry);
-                    
+
                     if (r2->id == ref->tbr.offset) {
                         r = r2;
                         break;
                     }
-                    
+
                     le3 = le3->Flink;
                 }
-                
+
                 if (!r) {
                     ERR("could not find subvol with id %llx\n", ref->tbr.offset);
                     return STATUS_INTERNAL_ERROR;
                 }
-                
+
                 Status = find_item_to_level(Vcb, r, &tp, firstitem, FALSE, mr->data->level + 1, NULL);
                 if (!NT_SUCCESS(Status) && Status != STATUS_NOT_FOUND) {
                     ERR("find_item_to_level returned %08x\n", Status);
                     return Status;
                 }
-                
+
                 t = tp.tree;
                 while (t && t->header.level < mr->data->level + 1) {
                     t = t->parent;
                 }
-                
+
                 if (!t)
                     ref->top = TRUE;
                 else {
                     metadata_reloc* mr2;
-                    
+
                     Status = add_metadata_reloc_parent(Vcb, items, t->header.address, &mr2, rollback);
                     if (!NT_SUCCESS(Status)) {
                         ERR("add_metadata_reloc_parent returned %08x\n", Status);
                         return Status;
                     }
-                    
+
                     ref->parent = mr2;
                 }
             } else if (ref->type == TYPE_SHARED_BLOCK_REF) {
                 metadata_reloc* mr2;
-                
+
                 Status = add_metadata_reloc_parent(Vcb, items, ref->sbr.offset, &mr2, rollback);
                 if (!NT_SUCCESS(Status)) {
                     ERR("add_metadata_reloc_parent returned %08x\n", Status);
                     return Status;
                 }
-                
+
                 ref->parent = mr2;
             }
-            
+
             le2 = le2->Flink;
         }
-        
+
         le = le->Flink;
     }
-    
+
     le = items->Flink;
     while (le != items) {
         metadata_reloc* mr = CONTAINING_RECORD(le, metadata_reloc, list_entry);
         LIST_ENTRY* le2;
         UINT32 hash;
-        
+
         mr->t = NULL;
-        
+
         hash = calc_crc32c(0xffffffff, (UINT8*)&mr->address, sizeof(UINT64));
-        
+
         le2 = Vcb->trees_ptrs[hash >> 24];
-        
+
         if (le2) {
             while (le2 != &Vcb->trees_hash) {
                 tree* t = CONTAINING_RECORD(le2, tree, list_entry_hash);
-                
+
                 if (t->header.address == mr->address) {
                     mr->t = t;
                     break;
                 } else if (t->hash > hash)
                     break;
-                
+
                 le2 = le2->Flink;
             }
         }
-        
+
         le = le->Flink;
     }
-    
+
     for (level = 0; level <= max_level; level++) {
         le = items->Flink;
         while (le != items) {
             metadata_reloc* mr = CONTAINING_RECORD(le, metadata_reloc, list_entry);
-            
+
             if (mr->data->level == level) {
                 BOOL done = FALSE;
                 LIST_ENTRY* le2;
@@ -693,7 +736,7 @@
                 tree_write* tw;
                 UINT64 flags;
                 tree* t3;
-                
+
                 if (mr->system)
                     flags = Vcb->system_flags;
                 else if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_MIXED_GROUPS)
@@ -700,33 +743,33 @@
                     flags = Vcb->data_flags;
                 else
                     flags = Vcb->metadata_flags;
-                
+
                 if (newchunk) {
                     ExAcquireResourceExclusiveLite(&newchunk->lock, TRUE);
-                    
+
                     if (newchunk->chunk_item->type == flags && find_metadata_address_in_chunk(Vcb, newchunk, &mr->new_address)) {
-                        increase_chunk_usage(newchunk, Vcb->superblock.node_size);
-                        space_list_subtract(Vcb, newchunk, FALSE, mr->new_address, Vcb->superblock.node_size, rollback);
+                        newchunk->used += Vcb->superblock.node_size;
+                        space_list_subtract(newchunk, FALSE, mr->new_address, Vcb->superblock.node_size, rollback);
                         done = TRUE;
                     }
-                    
+
                     ExReleaseResourceLite(&newchunk->lock);
                 }
-                
+
                 if (!done) {
                     ExAcquireResourceExclusiveLite(&Vcb->chunk_lock, TRUE);
-    
+
                     le2 = Vcb->chunks.Flink;
                     while (le2 != &Vcb->chunks) {
                         chunk* c2 = CONTAINING_RECORD(le2, chunk, list_entry);
-                        
+
                         if (!c2->readonly && !c2->reloc && c2 != newchunk && c2->chunk_item->type == flags) {
                             ExAcquireResourceExclusiveLite(&c2->lock, TRUE);
-                            
+
                             if ((c2->chunk_item->size - c2->used) >= Vcb->superblock.node_size) {
                                 if (find_metadata_address_in_chunk(Vcb, c2, &mr->new_address)) {
-                                    increase_chunk_usage(c2, Vcb->superblock.node_size);
-                                    space_list_subtract(Vcb, c2, FALSE, mr->new_address, Vcb->superblock.node_size, rollback);
+                                    c2->used += Vcb->superblock.node_size;
+                                    space_list_subtract(c2, FALSE, mr->new_address, Vcb->superblock.node_size, rollback);
                                     ExReleaseResourceLite(&c2->lock);
                                     newchunk = c2;
                                     done = TRUE;
@@ -733,51 +776,53 @@
                                     break;
                                 }
                             }
-                            
+
                             ExReleaseResourceLite(&c2->lock);
                         }
 
                         le2 = le2->Flink;
                     }
-                    
+
                     // allocate new chunk if necessary
                     if (!done) {
-                        newchunk = alloc_chunk(Vcb, flags);
-                        
-                        if (!newchunk) {
-                            ERR("could not allocate new chunk\n");
+                        Status = alloc_chunk(Vcb, flags, &newchunk, FALSE);
+
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("alloc_chunk returned %08x\n", Status);
                             ExReleaseResourceLite(&Vcb->chunk_lock);
-                            Status = STATUS_DISK_FULL;
                             goto end;
                         }
-                        
+
                         ExAcquireResourceExclusiveLite(&newchunk->lock, TRUE);
-                        
+
+                        newchunk->balance_num = Vcb->balance.balance_num;
+
                         if (!find_metadata_address_in_chunk(Vcb, newchunk, &mr->new_address)) {
                             ExReleaseResourceLite(&newchunk->lock);
+                            ExReleaseResourceLite(&Vcb->chunk_lock);
                             ERR("could not find address in new chunk\n");
                             Status = STATUS_DISK_FULL;
                             goto end;
                         } else {
-                            increase_chunk_usage(newchunk, Vcb->superblock.node_size);
-                            space_list_subtract(Vcb, newchunk, FALSE, mr->new_address, Vcb->superblock.node_size, rollback);
+                            newchunk->used += Vcb->superblock.node_size;
+                            space_list_subtract(newchunk, FALSE, mr->new_address, Vcb->superblock.node_size, rollback);
                         }
-                        
+
                         ExReleaseResourceLite(&newchunk->lock);
                     }
-                    
+
                     ExReleaseResourceLite(&Vcb->chunk_lock);
                 }
-                
+
                 // update parents
                 le2 = mr->refs.Flink;
                 while (le2 != &mr->refs) {
                     metadata_reloc_ref* ref = CONTAINING_RECORD(le2, metadata_reloc_ref, list_entry);
-                    
+
                     if (ref->parent) {
                         UINT16 i;
                         internal_node* in = (internal_node*)&ref->parent->data[1];
-                        
+
                         for (i = 0; i < ref->parent->data->num_items; i++) {
                             if (in[i].address == mr->address) {
                                 in[i].address = mr->new_address;
@@ -784,17 +829,17 @@
                                 break;
                             }
                         }
-                        
+
                         if (ref->parent->t) {
                             LIST_ENTRY* le3;
-                            
+
                             le3 = ref->parent->t->itemlist.Flink;
                             while (le3 != &ref->parent->t->itemlist) {
                                 tree_data* td = CONTAINING_RECORD(le3, tree_data, list_entry);
-                                
+
                                 if (!td->inserted && td->treeholder.address == mr->address)
                                     td->treeholder.address = mr->new_address;
-                                
+
                                 le3 = le3->Flink;
                             }
                         }
@@ -801,24 +846,24 @@
                     } else if (ref->top && ref->type == TYPE_TREE_BLOCK_REF) {
                         LIST_ENTRY* le3;
                         root* r = NULL;
-                        
+
                         // alter ROOT_ITEM
-                        
+
                         le3 = Vcb->roots.Flink;
                         while (le3 != &Vcb->roots) {
                             root* r2 = CONTAINING_RECORD(le3, root, list_entry);
-                            
+
                             if (r2->id == ref->tbr.offset) {
                                 r = r2;
                                 break;
                             }
-                            
+
                             le3 = le3->Flink;
                         }
-                        
+
                         if (r) {
                             r->treeholder.address = mr->new_address;
-                            
+
                             if (r == Vcb->root_root)
                                 Vcb->superblock.root_tree_addr = mr->new_address;
                             else if (r == Vcb->chunk_root)
@@ -826,25 +871,25 @@
                             else if (r->root_item.block_number == mr->address) {
                                 KEY searchkey;
                                 ROOT_ITEM* ri;
-                                
+
                                 r->root_item.block_number = mr->new_address;
-                                
+
                                 searchkey.obj_id = r->id;
                                 searchkey.obj_type = TYPE_ROOT_ITEM;
                                 searchkey.offset = 0xffffffffffffffff;
-                                
+
                                 Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, NULL);
                                 if (!NT_SUCCESS(Status)) {
                                     ERR("find_item returned %08x\n", Status);
                                     goto end;
                                 }
-                                
+
                                 if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
                                     ERR("could not find ROOT_ITEM for tree %llx\n", searchkey.obj_id);
                                     Status = STATUS_INTERNAL_ERROR;
                                     goto end;
                                 }
-                                
+
                                 ri = ExAllocatePoolWithTag(PagedPool, sizeof(ROOT_ITEM), ALLOC_TAG);
                                 if (!ri) {
                                     ERR("out of memory\n");
@@ -851,25 +896,29 @@
                                     Status = STATUS_INSUFFICIENT_RESOURCES;
                                     goto end;
                                 }
-                                
+
                                 RtlCopyMemory(ri, &r->root_item, sizeof(ROOT_ITEM));
-                                
-                                delete_tree_item(Vcb, &tp, rollback);
-                                
-                                if (!insert_tree_item(Vcb, Vcb->root_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, ri, sizeof(ROOT_ITEM), NULL, NULL, rollback)) {
-                                    ERR("insert_tree_item failed\n");
-                                    Status = STATUS_INTERNAL_ERROR;
+
+                                Status = delete_tree_item(Vcb, &tp);
+                                if (!NT_SUCCESS(Status)) {
+                                    ERR("delete_tree_item returned %08x\n", Status);
                                     goto end;
                                 }
+
+                                Status = insert_tree_item(Vcb, Vcb->root_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, ri, sizeof(ROOT_ITEM), NULL, NULL);
+                                if (!NT_SUCCESS(Status)) {
+                                    ERR("insert_tree_item returned %08x\n", Status);
+                                    goto end;
+                                }
                             }
                         }
                     }
-                    
+
                     le2 = le2->Flink;
                 }
-                
+
                 mr->data->address = mr->new_address;
-                
+
                 t3 = mr->t;
 
                 while (t3) {
@@ -876,25 +925,25 @@
                     UINT8 h;
                     BOOL inserted;
                     tree* t4 = NULL;
-                    
+
                     // check if tree loaded more than once
                     if (t3->list_entry.Flink != &Vcb->trees_hash) {
                         tree* nt = CONTAINING_RECORD(t3->list_entry_hash.Flink, tree, list_entry_hash);
-                        
+
                         if (nt->header.address == t3->header.address)
                             t4 = nt;
                     }
-                    
+
                     t3->header.address = mr->new_address;
-                    
+
                     h = t3->hash >> 24;
-                    
+
                     if (Vcb->trees_ptrs[h] == &t3->list_entry_hash) {
                         if (t3->list_entry_hash.Flink == &Vcb->trees_hash)
                             Vcb->trees_ptrs[h] = NULL;
                         else {
                             tree* t2 = CONTAINING_RECORD(t3->list_entry_hash.Flink, tree, list_entry_hash);
-                            
+
                             if (t2->hash >> 24 == h)
                                 Vcb->trees_ptrs[h] = &t2->list_entry_hash;
                             else
@@ -901,17 +950,17 @@
                                 Vcb->trees_ptrs[h] = NULL;
                         }
                     }
-                        
+
                     RemoveEntryList(&t3->list_entry_hash);
-                    
+
                     t3->hash = calc_crc32c(0xffffffff, (UINT8*)&t3->header.address, sizeof(UINT64));
                     h = t3->hash >> 24;
-                    
+
                     if (!Vcb->trees_ptrs[h]) {
                         UINT8 h2 = h;
-                        
+
                         le2 = Vcb->trees_hash.Flink;
-                        
+
                         if (h2 > 0) {
                             h2--;
                             do {
@@ -919,23 +968,23 @@
                                     le2 = Vcb->trees_ptrs[h2];
                                     break;
                                 }
-                                    
+
                                 h2--;
                             } while (h2 > 0);
                         }
                     } else
                         le2 = Vcb->trees_ptrs[h];
-                    
+
                     inserted = FALSE;
                     while (le2 != &Vcb->trees_hash) {
                         tree* t2 = CONTAINING_RECORD(le2, tree, list_entry_hash);
-                        
+
                         if (t2->hash >= t3->hash) {
                             InsertHeadList(le2->Blink, &t3->list_entry_hash);
                             inserted = TRUE;
                             break;
                         }
-                        
+
                         le2 = le2->Flink;
                     }
 
@@ -944,40 +993,40 @@
 
                     if (!Vcb->trees_ptrs[h] || t3->list_entry_hash.Flink == Vcb->trees_ptrs[h])
                         Vcb->trees_ptrs[h] = &t3->list_entry_hash;
-                    
+
                     if (data_items && level == 0) {
                         le2 = data_items->Flink;
-                        
+
                         while (le2 != data_items) {
                             data_reloc* dr = CONTAINING_RECORD(le2, data_reloc, list_entry);
                             LIST_ENTRY* le3 = t3->itemlist.Flink;
-                            
+
                             while (le3 != &t3->itemlist) {
                                 tree_data* td = CONTAINING_RECORD(le3, tree_data, list_entry);
-                                
+
                                 if (!td->inserted && td->key.obj_type == TYPE_EXTENT_DATA && td->size >= sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2)) {
                                     EXTENT_DATA* ed = (EXTENT_DATA*)td->data;
-                                    
+
                                     if (ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) {
                                         EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ed->data;
-                                        
+
                                         if (ed2->address == dr->address)
                                             ed2->address = dr->new_address;
                                     }
                                 }
-                                
+
                                 le3 = le3->Flink;
                             }
-                            
+
                             le2 = le2->Flink;
                         }
                     }
-                    
+
                     t3 = t4;
                 }
 
                 *((UINT32*)mr->data) = ~calc_crc32c(0xffffffff, (UINT8*)&mr->data->fs_uuid, Vcb->superblock.node_size - sizeof(mr->data->csum));
-                
+
                 tw = ExAllocatePoolWithTag(PagedPool, sizeof(tree_write), ALLOC_TAG);
                 if (!tw) {
                     ERR("out of memory\n");
@@ -984,66 +1033,65 @@
                     Status = STATUS_INSUFFICIENT_RESOURCES;
                     goto end;
                 }
-                
+
                 tw->address = mr->new_address;
                 tw->length = Vcb->superblock.node_size;
                 tw->data = (UINT8*)mr->data;
-                tw->overlap = FALSE;
-                
+
                 if (IsListEmpty(&tree_writes))
                     InsertTailList(&tree_writes, &tw->list_entry);
                 else {
                     BOOL inserted = FALSE;
-                    
+
                     le2 = tree_writes.Flink;
                     while (le2 != &tree_writes) {
                         tree_write* tw2 = CONTAINING_RECORD(le2, tree_write, list_entry);
-                        
+
                         if (tw2->address > tw->address) {
                             InsertHeadList(le2->Blink, &tw->list_entry);
                             inserted = TRUE;
                             break;
                         }
-                        
+
                         le2 = le2->Flink;
                     }
-                    
+
                     if (!inserted)
                         InsertTailList(&tree_writes, &tw->list_entry);
                 }
             }
-            
+
             le = le->Flink;
         }
     }
-    
+
+    Status = do_tree_writes(Vcb, &tree_writes, TRUE);
+    if (!NT_SUCCESS(Status)) {
+        ERR("do_tree_writes returned %08x\n", Status);
+        goto end;
+    }
+
     le = items->Flink;
     while (le != items) {
         metadata_reloc* mr = CONTAINING_RECORD(le, metadata_reloc, list_entry);
-        
-        Status = add_metadata_reloc_extent_item(Vcb, mr, rollback);
+
+        Status = add_metadata_reloc_extent_item(Vcb, mr);
         if (!NT_SUCCESS(Status)) {
             ERR("add_metadata_reloc_extent_item returned %08x\n", Status);
             goto end;
         }
-        
+
         le = le->Flink;
     }
-    
-    Status = do_tree_writes(Vcb, &tree_writes, NULL);
-    if (!NT_SUCCESS(Status)) {
-        ERR("do_tree_writes returned %08x\n", Status);
-        goto end;
-    }
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     while (!IsListEmpty(&tree_writes)) {
         tree_write* tw = CONTAINING_RECORD(RemoveHeadList(&tree_writes), tree_write, list_entry);
         ExFreePool(tw);
     }
-    
+
     return Status;
 }
 
@@ -1054,33 +1102,33 @@
     BOOL b;
     LIST_ENTRY items, rollback;
     UINT32 loaded = 0;
-    
+
     TRACE("chunk %llx\n", c->offset);
-    
+
     InitializeListHead(&rollback);
     InitializeListHead(&items);
-    
+
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-    
+
     searchkey.obj_id = c->offset;
     searchkey.obj_type = TYPE_METADATA_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
         goto end;
     }
-    
+
     do {
         traverse_ptr next_tp;
-        
+
         if (tp.item->key.obj_id >= c->offset + c->chunk_item->size)
             break;
-        
+
         if (tp.item->key.obj_id >= c->offset && (tp.item->key.obj_type == TYPE_EXTENT_ITEM || tp.item->key.obj_type == TYPE_METADATA_ITEM)) {
             BOOL tree = FALSE, skinny = FALSE;
-            
+
             if (tp.item->key.obj_type == TYPE_METADATA_ITEM && tp.item->size >= sizeof(EXTENT_ITEM)) {
                 tree = TRUE;
                 skinny = TRUE;
@@ -1087,32 +1135,32 @@
             } else if (tp.item->key.obj_type == TYPE_EXTENT_ITEM && tp.item->key.offset == Vcb->superblock.node_size &&
                        tp.item->size >= sizeof(EXTENT_ITEM)) {
                 EXTENT_ITEM* ei = (EXTENT_ITEM*)tp.item->data;
-                
+
                 if (ei->flags & EXTENT_ITEM_TREE_BLOCK)
                     tree = TRUE;
             }
-            
+
             if (tree) {
                 Status = add_metadata_reloc(Vcb, &items, &tp, skinny, NULL, c, &rollback);
-                
+
                 if (!NT_SUCCESS(Status)) {
                     ERR("add_metadata_reloc returned %08x\n", Status);
                     goto end;
                 }
-                
+
                 loaded++;
-                
+
                 if (loaded >= 64) // only do 64 at a time
                     break;
             }
         }
-    
+
         b = find_next_item(Vcb, &tp, &next_tp, FALSE, NULL);
-        
+
         if (b)
             tp = next_tp;
     } while (b);
-    
+
     if (IsListEmpty(&items)) {
         *changed = FALSE;
         Status = STATUS_SUCCESS;
